﻿-- Author      : Nogarder
-- Create Date : 2013/4/20 11:28:24
--
local ArrowList={}
NPA.EventHandler.RegisterEvent(6,"TargetArrow_SettingUpdated","TargetArrow_Main",function()
	local pairs=pairs
	local UnitGUID=UnitGUID
	local next=next
	local table_getn=table.getn
	--
	local NPA_EventHandler_FireEvent=NPA.EventHandler.FireEvent

	local NPA_DataCollector_GetUnitDataByGUID=NPA.DataCollector.GetUnitDataByGUID

	local NPA_ArrowManager_CreateArrow=NPA.ArrowManager.CreateArrow
	local NPA_ArrowManager_ManageArrow=NPA.ArrowManager.ManageArrow
	--
	local NPA_FrameToGUID_GetFrameByGUID=NPA.FrameToGUID.GetFrameByGUID
	local NPA_DataCollector_GetUnitFromGUID=NPA.DataCollector.GetUnitFromGUID
	local NPA_ArrowManager_SetColor=NPA.ArrowManager.SetColor
	--
	local GetArrow=function(index)
		--don't have to do recycle kind of thing
		--should be one arrow per frame
		--just return if already exists
		if(ArrowList[index])then
			return ArrowList[index]
		end
		--create new one
		ArrowList[index]=NPA_ArrowManager_CreateArrow(index)
		ArrowList[index]:Hide()
		return ArrowList[index]
	end
	--
	local PartyIDList={}
	for i=1,5 do
		PartyIDList[i]="party"..i
	end
	--if setting is empty, unregister event
	if(next(NPA_Setting.TargetArrow))then
		--
		local IndexChecker={
			--0=any, 1=friendly,2=neutral,3=hostile,4=self,5=target,6=focus,7=mouseover
			--8=party ,9=raid, 10=guild,11=friend, 12=arena
			--13= hostile player, 14=neutral player, 15=hostile player
			--16=hostile non-player, 17=neutral non-player, 18=hostile non-player
			[0]=function()
				return true
			end,
			[1]=function(unitdata)
				return unitdata.Faction==1
			end,
			[2]=function(unitdata)
				return unitdata.Faction==2
			end,
			[3]=function(unitdata)
				return unitdata.Faction==3
			end,
			[4]=function(unitdata)
				return unitdata.GUID==UnitGUID("player")
			end,
			[5]=function(unitdata)
				return unitdata.GUID==UnitGUID("target")
			end,
			[6]=function(unitdata)
				return unitdata.GUID==UnitGUID("focus")
			end,
			[7]=function(unitdata)
				return unitdata.GUID==UnitGUID("mouseover")
			end,
			[8]=function(unitdata)
				return unitdata.Faction==1 and NPA.FriendsList.PartyList[unitdata.Name]==true
			end,
			[9]=function(unitdata)
				return unitdata.Faction==1 and NPA.FriendsList.RaidList[unitdata.Name]==true
			end,
			[10]=function(unitdata)
				return unitdata.Faction==1 and NPA.FriendsList.GuildList[unitdata.Name]==true
			end,
			[11]=function(unitdata)
				return unitdata.Faction==1 and NPA.FriendsList.FriendList[unitdata.Name]==true
			end,
			[12]=function(unitdata)
				return unitdata.Faction==3 and NPA.FriendsList.ArenaList[unitdata.Name]==true
			end,
			[13]=function(unitdata)
				return unitdata.Faction==1 and unitdata.Type==1
			end,
			[14]=function(unitdata)
				return unitdata.Faction==2 and unitdata.Type==1
			end,
			[15]=function(unitdata)
				return unitdata.Faction==3 and unitdata.Type==1
			end,
			[16]=function(unitdata)
				return unitdata.Faction==1 and unitdata.Type~=1
			end,
			[17]=function(unitdata)
				return unitdata.Faction==2 and unitdata.Type~=1
			end,
			[18]=function(unitdata)
				return unitdata.Faction==3 and unitdata.Type~=1
			end,
		}
		local SettingList=NPA_Setting.TargetArrow
		local SettingCount=table_getn(SettingList)
		--
		NPA.EventHandler.RegisterEvent(7,"Target_Updated","TargetArrow_Main",function(unitdata)
			local startframe=NPA_FrameToGUID_GetFrameByGUID(unitdata.GUID)
			if(startframe)then
				local arrow=GetArrow(startframe)
				local targetunitdata=NPA_DataCollector_GetUnitDataByGUID(unitdata.TargetGUID)
				local endframe=NPA_FrameToGUID_GetFrameByGUID(unitdata.TargetGUID or 0)
				if(startframe:IsShown() and endframe and endframe:IsShown() and targetunitdata)then
					--check condition
 					for i=1,SettingCount do
						local setting=SettingList[i]
						if(IndexChecker[setting.From]~=nil and IndexChecker[setting.From](unitdata)==true and
							IndexChecker[setting.To]~=nil and IndexChecker[setting.To](targetunitdata)==true) then
							--all frame is visible
							if(arrow:IsShown() and arrow.Setting==setting)then --already shown and same profile, just extend its lifetime
								arrow.LifeTime=setting.LifeTime
							else
								--not shown, manage it
								--set startpoint
								arrow:SetPoint("CENTER",startframe,"CENTER",setting.StartOffsetX,setting.StartOffsetY)
								NPA_ArrowManager_ManageArrow(arrow,setting,setting.LifeTime,setting.FadeAlpha)
								--framelevel
								arrow:SetFrameLevel(setting.FrameLevel+arrow:GetParent():GetFrameLevel())
								arrow.Setting=setting
							end
							--set endpoint
							--arrow.EndPoint:SetParent(endframe) --don't set parent
							arrow.EndPoint:SetPoint("CENTER",endframe,"CENTER",setting.EndOffsetX,setting.EndOffsetY)
							--out of loop
							break;
						end
					end
				else--don't hide it here, it will be handled by timer
					--arrow:Hide()
				end
			end
		end)
		--
		local GetRange=function(unit1,unit2)
			local x,y=UnitPosition(unit1)
			if(x and y and (x~=0 or y~=0))then
				local px,py=UnitPosition(unit2)
				if(px and py and (px~=0 or py~=0))then
					return floor(((px-x)^2+(py-y)^2)^0.5)
				end
			end
			return 0
		end
		--rangecheck
		NPA.EventHandler.RegisterEvent(2,"DataCollector_Collectable_OnUpdate","TargetArrow_Main",nil)
		NPA.EventHandler.RegisterEvent(8,"Range_Updated","TargetArrow_Main",nil)
		--
		for _,setting in pairs(NPA_Setting.TargetArrow)do
			if(setting.RangeCheck>0)then	
				NPA.EventHandler.RegisterEvent(2,"DataCollector_Collectable_OnUpdate","TargetArrow_Main",function(unit,unitdata)
					local startframe=NPA_FrameToGUID_GetFrameByGUID(unitdata.GUID)
					if(not startframe)then
						return
					end
					local arrow=GetArrow(startframe)
					if(arrow:IsShown() and arrow.Setting.RangeCheck>0)then
						if(unitdata.TargetGUID==UnitGUID("player"))then
							--use player range detect if aviliable
							if(unitdata.RangeUpdated)then
								local range=unitdata.RangeClose
								local setting=arrow.Setting
								if(range>setting.RangeCheck)then
										--set color
									NPA_ArrowManager_SetColor(arrow,setting.RangeColor,setting.RangeEndColor)
								else
									NPA_ArrowManager_SetColor(arrow,setting.Color,setting.EndColor)
								end
							else
								local targetunit="player"
								local range=GetRange(unit,targetunit)
								local setting=arrow.Setting
								if(range>setting.RangeCheck)then
									--set color
									NPA_ArrowManager_SetColor(arrow,setting.RangeColor,setting.RangeEndColor)
								else
									NPA_ArrowManager_SetColor(arrow,setting.Color,setting.EndColor)
								end
							end
						else
							local targetunit=NPA_DataCollector_GetUnitFromGUID(unitdata.TargetGUID)
							if(targetunit)then
								local range=GetRange(unit,targetunit)
								local setting=arrow.Setting
								if(range>setting.RangeCheck)then
									--set color
									NPA_ArrowManager_SetColor(arrow,setting.RangeColor,setting.RangeEndColor)
								else
									NPA_ArrowManager_SetColor(arrow,setting.Color,setting.EndColor)
								end
							end
						end
					end
				end)
				--
				NPA.EventHandler.RegisterEvent(8,"Range_Updated","TargetArrow_Main",function(framedata)
					if(framedata.UnitData.RangeUpdated and framedata.GUID==UnitGUID("target"))then
						local startframe=NPA_FrameToGUID_GetFrameByGUID(UnitGUID("player"))
						if(not startframe)then
							return
						end
						local arrow=GetArrow(startframe)
						if(arrow:IsShown() and arrow.Setting.RangeCheck>0)then
							local setting=arrow.Setting
							if(framedata.UnitData.RangeClose>setting.RangeCheck)then
								NPA_ArrowManager_SetColor(arrow,setting.RangeColor,setting.RangeEndColor)
							else
								NPA_ArrowManager_SetColor(arrow,setting.Color,setting.EndColor)
							end
						end
					end
				end)
				break
			end
		end
	else
		NPA.EventHandler.RegisterEvent(7,"Target_Updated","TargetArrow_Main",nil)
	end
	--hide all arrow ,force them to update
	for _,arrow in pairs(ArrowList)do
		arrow:Hide()
	end
end)
--

