﻿-- Author      : Nogarder
-- Create Date : 2013/4/20 14:45:08
NPA_Options.RegisterPageFunc("TargetArrow",function()
	local pairs=pairs
	local CopyTable=CopyTable
	local table_remove=table.remove
	--localization
	local Localization=NPA_Options.Localization.PagesTargetArrowEditor
	local Tooltips=Localization.Tooltips
	---
	local parent=NPA_Options.MainFrame
	local modulelist={}
	--
	local main=NPA_Options.Template.CreatePriorityEdit(parent,Localization["SelectProfile"],400,320,50,nil,nil)
	main:Hide()

	local page=main.Frame
	local scroll=main.Scroll
	page.KeepDefault=false
	
	local GetFromToList=function()
		return Localization.FromToList
	end
	
	--place holder for dropdownmenu without data
	local EmptyFunc=function()
		return {}
	end
	--
	local SetButtonDisplay=function(button,entry)
		NPA_Options.Template.SetDropDownEditor(button.From,entry.From)
		--
		NPA_Options.Template.SetDropDownEditor(button.To,entry.To)
	end
	--
	page.ButtonCreateFunc=function(button)
		local label=button:CreateFontString()
		NPA_Options.SetTextFont(label)
		label:SetPoint("LEFT",button,"LEFT",10,0)
		--from
		local fromselector=NPA_Options.Template.CreateDropDownEditor(button,150,Localization["From"],Tooltips["From"],GetFromToList,20)
		fromselector:SetPoint("LEFT",label,"RIGHT",10,0)
		--to
		local toselector=NPA_Options.Template.CreateDropDownEditor(button,150,Localization["To"],Tooltips["To"],GetFromToList,20)
		toselector:SetPoint("LEFT",fromselector,"RIGHT",30,0)
		--editor
		local editbutton=NPA_Options.Template.CreateButton(button,40,20,Localization["Edit"])
		editbutton:SetPoint("LEFT",toselector,"RIGHT",30,0)
		--
		button.LabelText=label
		button.From=fromselector
		button.To=toselector
		button.Edit=editbutton
		--
		fromselector.OnValueUpdateFunc=function()
			Entry[button.EntryIndex].From=fromselector.Value
			--
			SetButtonDisplay(button,Entry[button.EntryIndex])
		end
		--
		toselector.OnValueUpdateFunc=function()
			Entry[button.EntryIndex].To=toselector.Value
		end
		editbutton:HookScript("OnMouseUp",function()
			NPA_Options.SetPage("TargetArrowEditor",main,Entry[button.EntryIndex])
		end)
	end
	page.ButtonUpdateFunc=function(button,index)
		button.LabelText:SetText(index)
		SetButtonDisplay(button,Entry[index])
	end
	local Refresh=function()
		NPA_Options.Template.UpdatePriorityEdit(scroll,Entry)
	end

	page.LoadFunc=function(default)
		--load entry
		if(default)then
			Entry=NPA.SettingManager.GetDefault("TargetArrow")
		else
			Entry=CopyTable(NPA_Setting.TargetArrow)
		end
		Refresh()
	end
	page.SaveFunc=function(matchtable)
		--sort by new order then save
		local entry={}
		for index,index2 in pairs(matchtable)do
			entry[index]=CopyTable(Entry[index2])
		end

		NPA_Setting.TargetArrow=entry
		--refresh
		Entry=CopyTable(entry)
		Refresh()
		--also fire an event
		NPA.EventHandler.FireEvent(6,"TargetArrow_SettingUpdated")
	end
	--
	page.OnCopyFunc=function(oldindex,newindex)
		Entry[newindex]=CopyTable(Entry[oldindex])
		Refresh()
	end
	page.OnDeleteFunc=function(oldindex)
		table_remove(Entry,oldindex)
		Refresh()
	end
	page.OnRenameFunc=function(oldindex,newindex)
		Entry[newindex]=CopyTable(Entry[oldindex])
		table_remove(Entry,oldindex)
		Refresh()
	end
	page.OnCreateFunc=function(newindex)
		local default=NPA.SettingManager.GetDefault("TargetArrow")
		Entry[newindex]=CopyTable(default)
		Refresh()
	end
	--
	main.OnSetFunc=function()
		page.LoadFunc()
	end
	----
	NPA_Options.RegisterPage("TargetArrow",main)
end)